package crafttweaker.mc1120.recipes;

import crafttweaker.api.recipes.*;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.NonNullList;
import net.minecraft.world.World;
import net.minecraftforge.registries.IForgeRegistryEntry;

import static crafttweaker.api.minecraft.CraftTweakerMC.getItemStack;

/**
 * @author Stan
 */
public class ShapelessRecipeAdvanced extends IForgeRegistryEntry.Impl<IRecipe> implements IRecipe, IMTRecipe {
    
    private final ShapelessRecipe recipe;
    
    public ShapelessRecipeAdvanced(ShapelessRecipe recipe) {
        this.recipe = recipe;
    }
    
    @Override
    public boolean func_77569_a(InventoryCrafting inventory, World world) {
        return recipe.matches(MCCraftingInventory.get(inventory));
    }
    
    @Override
    public ItemStack func_77572_b(InventoryCrafting inventory) {
        return getItemStack(recipe.getCraftingResult(MCCraftingInventory.get(inventory))).func_77946_l();
    }
    
    @Override
    public boolean func_194133_a(int x, int y) {
        return x+y >= recipe.getSize();
    }
    
    @Override
    public ItemStack func_77571_b() {
        return getItemStack(recipe.getOutput());
    }
    
    @Override
    public NonNullList<ItemStack> func_179532_b(InventoryCrafting inv) {
        return NonNullList.func_191196_a();
    }
    
    @Override
    public ICraftingRecipe getRecipe() {
        return recipe;
    }
}
